#include "StdAfx.h"
#include "IECtrl.h"

#include "ScriptletConstant.h"

REGISTER_COMPONENT_CREATOR(SCRIPTLET_IECTRL_NODE, CIECtrlAdapter);
CIECtrlAdapter::CIECtrlAdapter()
{
	m_IECtrl = NULL;
}
CIECtrlAdapter::~CIECtrlAdapter()
{
	if ( NULL != m_IECtrl )
	{
		this->DetachWindowAdaptee();
		delete m_IECtrl;
		m_IECtrl = NULL;
	}
}
HWND CIECtrlAdapter::CreateExWindow( LPTSTR szClassName, DWORD dwStyle, HWND hWndParent, UINT uID, DWORD dwStyleEx )
{
	HWND hWnd = NULL;
	m_IECtrl = new CIECtrl;
	if (TRUE == m_IECtrl->Create(hWndParent, dwStyle, dwStyleEx, uID))
	{
		hWnd = m_IECtrl->m_hWnd;
		this->AttachWindowAdaptee(hWnd);
	}
	return hWnd;
}
void CIECtrlAdapter::Navigate(LPCTSTR url)
{
	if ( NULL != m_IECtrl )
	{
		CComPtr<IWebBrowser2> spWebBrowser2 ;	
		HRESULT hr = m_IECtrl->QueryControl(IID_IWebBrowser2, reinterpret_cast<void **>(&spWebBrowser2));
		if (SUCCEEDED(hr))
		{
			CComVariant vEmpty ;
			CComVariant vFlags = short(0) ;
			spWebBrowser2->Navigate(CComBSTR(url), &vFlags, &vEmpty, &vEmpty, &vEmpty);
		}
	}
}

CIECtrl::CIECtrl(void)
{
}

CIECtrl::~CIECtrl(void)
{
	if (IsWindow())
		DestroyWindow();
}
BOOL CIECtrl::Create(HWND hWndParent, DWORD dwStyle, DWORD dwStyleEx, UINT uID)
{	
	HWND hWnd = CWindowImpl<CIECtrl, CAxWindow>::Create(hWndParent, CRect(0, 0, 0, 0), _T("about:blank"), dwStyle, dwStyleEx, uID) ;
	if (hWnd != NULL)
	{
		CComPtr<IAxWinAmbientDispatch> spAmbient ;
		HRESULT hr = QueryHost(&spAmbient) ;
		if ((SUCCEEDED(hr)) && (spAmbient != NULL))
		{
			spAmbient->put_AllowContextMenu(VARIANT_FALSE) ;			
		}
		/*CComPtr<IWebBrowser2> spWebBrowser2 ;	
		hr = QueryControl(IID_IWebBrowser2, reinterpret_cast<void **>(&spWebBrowser2));
		if (SUCCEEDED(hr))
		{
			CComVariant vEmpty ;
			CComVariant vFlags = short(0) ;
			spWebBrowser2->Navigate(_T("www.naver.com"), &vFlags, &vEmpty, &vEmpty, &vEmpty);
		}*/
	}
	return TRUE;
}